open Base

type t = {
  db: Sqlite3.db
}

let init db =
  { db }

let create ~user_id ~content { db } =
  let open Sqlite3.Data in
  let open Entry_template in
  Oksql.exec_only db
    "INSERT INTO diary_entry_templates \
     (user_id, content) \
     VALUES \
     (:user_id, :content);"
    ~params:[
      ":user_id", TEXT user_id;
      ":content", TEXT content;
    ];
  { user_id; content }

let get_by_user_id ~user_id { db }=
  let open Sqlite3.Data in
  let results = Oksql.exec_fetch (module Entry_template) db
      "SELECT user_id, content \
       FROM diary_entry_templates \
       WHERE user_id = :user_id;"
      ~params:[":user_id", TEXT user_id]
  in
  Array.find ~f:(Fn.const true) results
